<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Muhammed Alat <alat@bizlogix.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Change Password' for the 'changepassword' extension.
 *
 * @author	Muhammed Alat <alat@bizlogix.de>
 * @package	TYPO3
 * @subpackage	tx_changepassword
 */
class tx_changepassword_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_changepassword_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_changepassword_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'changepassword';	// The extension key.


	function init($conf) {
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin

		// Get the logged in user id or return false
		$this->config['userid'] = $GLOBALS["TSFE"]->loginUser ? $GLOBALS['TSFE']->fe_user->user['uid'] : false;
		
		// Getting the pid list via the flexform
		$this->config['pages'] = $this->cObj->data['pages'];
		
		// Template code
		$this->config['templateFile'] = $this->cObj->fileResource( $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'template_file', 'sDEF') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'templateFile', 'sDEF')  : t3lib_extMgm::siteRelPath($this->extKey) . 'res/template.html');

	}
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content, $conf) {
		$this->pi_USER_INT_obj = 1;
		$this->init($conf);
		if(!$this->config['userid']) {
			return 'User is not logged in. (CODE: 61 Trabzon)';
		}
		$content = '';
		
		// Get Part of the Template
		$template = $this->cObj->getSubpart($this->config['templateFile'], '###TEMPLATE###');
		$markerArray=array();

		// Save new password
		$markerArray['###STATUS###'] = '';
		if(isset($this->piVars['save'])) {
			$markerArray['###STATUS###'] = '<p style="font-weight:bold;">' . tx_changepassword_pi1::savePassword() . '</p>';
		}

		$markerArray['###FORM_ACTION###'] = $this->pi_getPageLink($GLOBALS['TSFE']->id);
		$markerArray['###LEGEND###'] =  $this->pi_getLL('legend');
		$markerArray['###OLDPASSWORD###'] =  $this->pi_getLL('oldpassword');
		$markerArray['###NEWPASSWORD###'] =  $this->pi_getLL('newpassword');
		$markerArray['###RENEWPASSWORD###'] =  $this->pi_getLL('renewpassword');
		$markerArray['###SUBMIT###'] =  $this->pi_getLL('submit');
		
		// build template
		$content .= $this->cObj->substituteMarkerArrayCached($template, $markerArray, $subpartArray,array());

		
		return $this->pi_wrapInBaseClass($content);
	}

	function savePassword() {
		$content = '';
		$npw= '';

		// Check old password
		$resOldPassword = $GLOBALS['TYPO3_DB']->exec_SELECTquery (
			'password', // SELECT
			'fe_users', // FROM
			'uid = ' . $this->config['userid'] .' AND pid = ' . $this->config['pages'] //WHERE
		);
		$arrayPassword = mysql_fetch_assoc($resOldPassword);

		$updatePassword = array('password' => '');

		if (t3lib_extMgm::isLoaded('saltedpasswords')) {
			if(strcmp(crypt($this->piVars['oldpassword'],$arrayPassword['password']),$arrayPassword['password'])!=0) {
				return tx_changepassword_pi1::wrongOldPassword();
			}
			if(strcmp($this->piVars['newpassword'],$this->piVars['repassword'])!=0) {
				return tx_changepassword_pi1::twoDifferentNewPasswords();
			}
			if( strlen($this->piVars['newpassword']) < 6 ) {
				return tx_changepassword_pi1::toShortPassword();
			}

			include_once(t3lib_extMgm::extPath('saltedpasswords').'classes/salts/class.tx_saltedpasswords_salts_md5.php');
			$classSalted = t3lib_div::makeInstanceClassName('tx_saltedpasswords_salts_md5');
			$instaceSalted = new $classSalted();
			$updatePassword['password'] = $instaceSalted->getHashedPassword($this->piVars['newpassword']);
		} else if (t3lib_extMgm::isLoaded('kb_md5fepw')) {
			if(strcmp(md5($this->piVars['oldpassword']),$arrayPassword['password'])!=0) {
				return tx_changepassword_pi1::wrongOldPassword();
			}
			if(strcmp($this->piVars['newpassword'],$this->piVars['repassword'])!=0) {
				return tx_changepassword_pi1::twoDifferentNewPasswords();
			}
			if( strlen($this->piVars['newpassword']) < 6 ) {
				return tx_changepassword_pi1::toShortPassword();
			}
			$updatePassword['password'] = md5($this->piVars['newpassword']);
		} else {
			if(strcmp($this->piVars['oldpassword'],$arrayPassword['password'])!=0) {
				return tx_changepassword_pi1::wrongOldPassword();
			}
			if(strcmp($this->piVars['newpassword'],$this->piVars['repassword'])!=0) {
				return tx_changepassword_pi1::twoDifferentNewPasswords();
			}
			if( strlen($this->piVars['newpassword']) < 6 ) {
				return tx_changepassword_pi1::toShortPassword();
			}
			$updatePassword['password'] = $this->piVars['newpassword'];
		}

		$updateQueryStatus = $GLOBALS['TYPO3_DB']->exec_UPDATEquery (
			'fe_users',
			'uid = ' . $this->config['userid'] . ' AND pid = ' . $this->config['pages'],
			$updatePassword
		);

		if($updateQueryStatus != 1) {
			return $updateQueryStatus;
		}
		return $this->pi_getLL('passwordsaved');
	}

	function wrongOldPassword() {
		return $this->pi_getLL('wrongOldPassword');
	}

	function twoDifferentNewPasswords() {
		return $this->pi_getLL('twodifferentnewpasswords');
	}

	function toShortPassword() {
		return $this->pi_getLL('toshortpassword');
	}

}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/changepassword/pi1/class.tx_changepassword_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/changepassword/pi1/class.tx_changepassword_pi1.php']);
}

?>
